
/* Generated by Interface Builder */

#import "MyView.h"
#import <AppKit/NSSliderCell.h>
#import <AppKit/NSButton.h>
#import <stdlib.h>
/* #import <AppKit/event.h> */
#import <AppKit/NSApplication.h>
#import <AppKit/NSMatrix.h>
#import <AppKit/NSPasteboard.h>
#import <Foundation/NSData.h>
#import <math.h>

@implementation MyView

#define	TITLEHEIGHT 	15.0

double	centerx, centery, cubesize;
int		dodecahedroncells[12][5] = 
			 {{0, 7, 18, 19, 9},
			 {0, 6, 14, 15, 8},
			 {1, 10, 16, 17, 12},
			 {1, 13, 20, 21, 11},
			 {2, 15, 17, 26, 27},
			 {2, 14, 16, 22, 23},
			 {3, 19, 21, 28, 29},
			 {3, 18, 20, 24, 25},
			 {4, 24, 7, 6, 22},
			 {4, 25, 11, 10, 23},
			 {5, 28, 9, 8, 26},
			 {5, 29, 13, 12, 27}};
int		icosahedroncells[20][3] =
			{{0, 7, 13},
			{0, 6, 12},
			{1, 26, 27},
			{1, 28, 29},
			{2, 8, 9},
			{2, 22, 25},
			{3, 10, 11},
			{3, 14, 17},
			{4, 15, 16},
			{4, 20, 21},
			{5, 18, 19},
			{5, 23, 24},
			{11, 12, 15},
			{14, 16, 27},
			{17, 19, 29},
			{10, 13, 18},
			{6, 8, 20},
			{21, 22, 26},
			{23, 25, 28},
			{7, 9, 24}}; 
			
 #include "./cell120vertexdata"

 #include "./cell120celldata"

- (void) doRotate
{
    int             i;
    double          new1, new2;
    NSInteger		SF;

    SF = [[RotateAdjust selectedCell] tag];
    [self SetAngle:LR :SF];
    switch (whichRotation) {
	case XYROT:		
    		for (i = 0; i < vertices; i++) {
            		new1 = C * cube[i][0] + S * cube[i][1];
           		new2 = - S * cube[i][0] + C * cube[i][1];
            		cube[i][0] = new1;
            		cube[i][1] = new2;
            		}
		break;
	case YZROT:
		for (i = 0; i < vertices; i++) {
                    new1 = C * cube[i][1] + S * cube[i][2];
                    new2 = - S * cube[i][1] + C * cube[i][2];
                    cube[i][1] = new1;
                    cube[i][2] = new2;
                    }
            	break;
	case ZXROT:
		for (i = 0; i < vertices; i++) {
                    new1 = C * cube[i][0] + S * cube[i][2];
                    new2 = - S * cube[i][0] + C * cube[i][2];
                    cube[i][0] = new1;
                    cube[i][2] = new2;
                    }
           	break;
	case XWROT:
		for (i = 0; i < vertices; i++) {
                    new1 = C * cube[i][0] + S * cube[i][3];
                    new2 = - S * cube[i][0] + C * cube[i][3];
                    cube[i][0] = new1;
                    cube[i][3] = new2;
                    }
            	break;
	case YWROT:
		for (i = 0; i < vertices; i++) {
                    new1 = C * cube[i][1] + S * cube[i][3];
                    new2 = - S * cube[i][1] + C * cube[i][3];
                    cube[i][1] = new1;
                    cube[i][3] = new2;
                    }
            	break;
	case ZWROT:
		for (i = 0; i < vertices; i++) {
                    new1 = C * cube[i][2] + S * cube[i][3];
                    new2 = - S * cube[i][2] + C * cube[i][3];
                    cube[i][2] = new1;
                    cube[i][3] = new2;
                    }
           	 break;
	}

    [self display]; 
}

- (void) handler1: (NSTimer *)Timer
{
        [self doRotate];
}

			
- (void)mouseDown: (NSEvent *)theEvent
{
        if (! timerActive) {

                rotateTimer = [NSTimer
                        scheduledTimerWithTimeInterval:0.02
                        target:self selector:@selector(handler1:)
                        userInfo:nil repeats:YES] ;
      			[NSCursor setHiddenUntilMouseMoves:YES];
		timerActive = YES;
		}

	else {
		[rotateTimer invalidate];
		/* [rotateTimer release]; */
		timerActive = NO;
                [NSCursor setHiddenUntilMouseMoves:NO];		
	}

}


- (void)initializeTetrahedron
{
	int		i, j, k= 0;
	double	sign;
	
	vertices = 4;
	lines = 6;
	cells = 4;
	figure = TETRAHEDRON;
	
	sign = 1.0;
	for (i = 0; i < 4; i++) {
		cube[i][0] = cos((2* i * PI) / 4)* TETRAHEDRONSIZE;
		cube[i][1] = sin((2* i * PI) / 4)* TETRAHEDRONSIZE;
		cube[i][2] = sign/ sqrt(2.0) * TETRAHEDRONSIZE;
		sign = - sign;
		}

	for (i = 0; i < 3; i++)
		for (j = i + 1; j < 4; j++) {
			switch (i) {
				case 0:	k = j - 1; break;
				case 1:	k = j + 1; break;
				case 2:	k = 5; break;
				}
			startline[ k ] = i;
			endline[ k] = j;
			} 
}

- (void)initializeCube
{
	int i, j, k;
	
	vertices = 8;
	lines = 12;
	cells = 6;
	figure = CUBE;
	
	for (i = 0; i < 2; i++)
		for (j = 0; j < 2; j++)
			for (k = 0; k < 2; k++) {
			cube[i + 2*j + 4*k][0] = 1.0 * (1 - 2 * i) * CUBESIZE;
                        cube[i + 2*j + 4*k][1] = 1.0 * (1 - 2 * j) * CUBESIZE;
                        cube[i + 2*j + 4*k][2] = 1.0 * (1 - 2 * k) * CUBESIZE;
				cube[i + 2*j + 4*k][3] = 0;
				}
					
	for (i = 0; i < 2; i++)
		for (j = 0; j < 2; j++) {
			startline[i + 2*j] = 0 + 2* i + 4*j;
			endline[i + 2*j] = 1 + 2*i + 4*j;
			startline[i + 2*j + 4] = 0 +  i + 4*j;
			endline[i + 2*j + 4] = 2 + i + 4*j ;
			startline[i + 2*j + 8] = 0 +  i + 2*j;
			endline[i + 2*j + 8] = 4 + i + 2*j;
  			} 
}

- (void)initializeOctahedron
{
	int 		i, j, theline = 0;
	double 	sign;
	
	vertices = 6;
	lines = 12;
	cells = 8;
	figure = OCTAHEDRON;

	sign = 1.0;
	for (i = 0; i < 6; i++) {
		cube[i][0] = cos(i * PI / 3) * OCTAHEDRONSIZE;
		cube[i][1] = sin(i * PI / 3) * OCTAHEDRONSIZE;
		cube[i][2] = sign / sqrt(2.0) * OCTAHEDRONSIZE;
		sign = - sign;
		}
		
	for (i = 0; i < 5; i++)
	for (j = i + 1; j < 6; j++) 
		if ((j - i )!= 3) {
		switch(i) {
			case 0: if (j < 3) theline = j - 1; else theline = j - 2; break;
			case 1: if (j < 4) theline = j + 2; else theline = j + 1; break;
			case 2: theline = j + 4; break; 
			case 3: theline = j + 5; break;
			case 4: theline = 11; break;
			} 
		startline[theline] = i;
		endline[theline] = j;
		} 
}

- (void)initializeDodecahedron
{
	int 		i, j, k, theline;
	double	isign, jsign, ksign;
	double	shortnum, longnum;
	
	vertices = 20;
	lines = 30;
	cells = 12;
	figure = DODECAHEDRON;
	
	longnum = (sqrt(5) + 1.0) / 2.0;	/* golden mean */
	shortnum = (sqrt(5) - 1.0) / 2.0;
	
	ksign = 1.0;
	for (k = 0; k < 2; k++) {
		jsign = 1.0;
		for (j = 0; j < 2; j++) {
			isign = 1.0;
			for (i = 0; i < 2; i++) {
				theline = i + 2 * j + 4 * k;
				cube[theline][0] = isign * DODECAHEDRONSIZE;
				cube[theline][1] = jsign * DODECAHEDRONSIZE;
				cube[theline][2] = ksign* DODECAHEDRONSIZE;
				cube[theline][3] = 0.0;
				isign = - isign;
				}
			jsign = - jsign;
			}
		ksign = - ksign;
		}
	
	jsign = 1.0;
	for (j = 0; j < 2; j++) {
		isign = 1.0;
		for (i = 0; i < 2; i++) {
			theline = 8 + i + 2*j;
			cube[theline][0] = 0.0;
			cube[theline][1] = isign * shortnum * DODECAHEDRONSIZE;
			cube[theline][2] = jsign * longnum * DODECAHEDRONSIZE;
			cube[theline][3] = 0.0;
			isign = - isign;
			}
		jsign = - jsign;
		}
		
	jsign = 1.0;
	for (j = 0; j < 2; j++) {
		isign = 1.0;
		for (i = 0; i < 2; i++) {
			theline = 12 + i + 2*j;
			cube[theline][0] = jsign * longnum * DODECAHEDRONSIZE;
			cube[theline][1] = 0.0;
			cube[theline][2] = isign * shortnum * DODECAHEDRONSIZE;
			cube[theline][3] = 0.0;
			isign = - isign;
			}
		jsign = - jsign;
		}

	jsign = 1.0;
	for (j = 0; j < 2; j++) {
		isign = 1.0;
		for (i = 0; i < 2; i++) {
			theline = 16 + i + 2*j;
			cube[theline][0] = isign * shortnum * DODECAHEDRONSIZE; ;
			cube[theline][1] =  jsign * longnum * DODECAHEDRONSIZE;
			cube[theline][2] = 0.0;
			cube[theline][3] = 0.0;
			isign = - isign;
			}
		jsign = - jsign;
		}

		
	startline[0] = 8;	endline[0] = 9;
	startline[1] = 10;	endline[1] = 11;
	startline[2] = 12;	endline[2] = 13;
	startline[3] = 14;	endline[3] = 15;
	startline[4] = 16;	endline[4] = 17;
	startline[5] = 18;	endline[5] = 19;
	startline[6] = 8;	endline[6] = 0;
	startline[7] = 8;	endline[7] = 1;
	startline[8] = 9;	endline[8] = 2;
	startline[9] = 9;	endline[9] = 3;
	startline[10] = 10;	endline[10] = 4;
	startline[11] = 10;	endline[11] = 5;
	startline[12] = 11;	endline[12] = 6;
	startline[13] = 11;	endline[13] = 7;
	startline[14] = 12;	endline[14] = 0;
	startline[15] = 12;	endline[15] = 2;
	startline[16] = 13;	endline[16] = 4;
	startline[17] = 13;	endline[17] = 6;
	startline[18] = 14;	endline[18] = 1;
	startline[19] = 14;	endline[19] = 3;
	startline[20] = 15;	endline[20] = 5;
	startline[21] = 15;	endline[21] = 7;
	startline[22] = 16;	endline[22] = 0;
	startline[23] = 16;	endline[23] = 4;
	startline[24] = 17;	endline[24] = 1;
	startline[25] = 17;	endline[25] = 5;
	startline[26] = 18;	endline[26] = 2;
	startline[27] = 18;	endline[27] = 6;
	startline[28] = 19;	endline[28] = 3;
	startline[29] = 19;	endline[29] = 7; 
}

- (void)initializeIcosahedron
{
	int		i, j, theline;
	double	longnum, shortnum;
	double	isign, jsign;
	
	vertices = 12;
	lines = 30;
	cells = 20;
	figure = ICOSAHEDRON;
	
	shortnum = 0.5257;					/* ?? */
	longnum = ((sqrt(5) + 1) / 2) * shortnum;
	
	isign = 1.0;
	for (i = 0; i < 2; i++) {
		jsign = 1.0;
		for (j = 0; j < 2; j++) {
			theline = j + 2*i;
			cube[theline][0] = isign * longnum * ICOSAHEDRONSIZE;
			cube[theline][1] = jsign * shortnum * ICOSAHEDRONSIZE;
			cube[theline][2] = 0.0;
			cube[theline][3] = 0.0;
			jsign = - jsign;
			}
		isign = - isign;
		}
		
	isign = 1.0;
	for (i = 0; i < 2; i++) {
		jsign = 1.0;
		for (j = 0; j < 2; j++) {
			theline = 4 + j + 2*i;
			cube[theline][0] = 0.0;
			cube[theline][1] = isign * longnum * ICOSAHEDRONSIZE;
			cube[theline][2] = jsign * shortnum * ICOSAHEDRONSIZE;
			cube[theline][3] = 0.0;
			jsign = - jsign;
			}
		isign = - isign;
		}

	isign = 1.0;
	for (i = 0; i < 2; i++) {
		jsign = 1.0;
		for (j = 0; j < 2; j++) {
			theline = 8 + j + 2*i;
			cube[theline][0] = jsign * shortnum * ICOSAHEDRONSIZE;
			cube[theline][1] = 0.0;
			cube[theline][2] =  isign * longnum * ICOSAHEDRONSIZE;
			cube[theline][3] = 0.0;
			jsign = - jsign;
			}
		isign = - isign;
		}

	
	startline[0] = 2;	endline[0] = 3;
	startline[1] = 0;	endline[1] = 1;
	startline[2] = 4;	endline[2] = 5;
	startline[3] = 6;	endline[3] = 7;
	startline[4] = 8;	endline[4] = 9;
	startline[5] = 10;	endline[5] = 11;
	startline[6] = 2;	endline[6] = 9;
	startline[7] = 2;	endline[7] = 11;
	startline[8] = 2;	endline[8] = 4;
	startline[9] = 2;	endline[9] = 5;
	startline[10] = 3;	endline[10] = 7;
	startline[11] = 3;	endline[11] = 6;
	startline[12] = 3;	endline[12] = 9;
	startline[13] = 3;	endline[13] = 11;
	startline[14] = 6;	endline[14] = 1;
	startline[15] = 6;	endline[15] = 9;
	startline[16] = 6;	endline[16] = 8;
	startline[17] = 7;	endline[17] = 1;
	startline[18] = 7;	endline[18] = 11;
	startline[19] = 7;	endline[19] = 10;
	startline[20] = 4;	endline[20] = 9;
	startline[21] = 4;	endline[21] = 8;
	startline[22] = 4;	endline[22] = 0;
	startline[23] = 5;	endline[23] = 10;
	startline[24] = 5;	endline[24] = 11;
	startline[25] = 5;	endline[25] = 0;
	startline[26] = 8;	endline[26] = 0;
	startline[27] = 8;	endline[27] = 1;
	startline[28] = 10;	endline[28] = 0;
	startline[29] = 10;	endline[29] = 1; 
}

- (void)initialize4Tetrahedron
{
	int		i, j, theline= 0;
	
	figure = TETRAHEDRON4;
	vertices = 5;
	lines = 10;
	cells =  5;
	
	for (i = 0; i < 5; i++)
		for (j = 1; j <= 2; j++) {
			cube[i][2*j - 2] = cos((2* j * i * PI) / 5)* TETRAHEDRON4SIZE;
			cube[i][2*j - 1] = sin((2* j * i * PI) / 5)* TETRAHEDRON4SIZE;
			}

	for (i = 0; i < 4; i++)
		for (j = i + 1;  j < 5; j++) {
		switch(i) {
			case 0:	theline = j - 1; break;
			case 1:	theline = j  + 2; break;
			case 2:	theline = j + 4; break;
			case 3:	theline = 9;
			}
		startline[theline] = i;
		endline[theline] = j;
		} 
}

- (void)initialize4Cube
{
	int i, j, k, l;
	
	figure = CUBE4;
	vertices = 16;
	lines = 32;
	cells = 8;
	
	for (i = 0; i < 2; i++)
		for (j = 0; j < 2; j++)
			for (k = 0; k < 2; k++)
				for (l = 0; l < 2; l++) {
					cube[i + 2*j + 4*k + 8*l][0] = 1.0 * (1 - 2 * i) * CUBESIZE;
                                	cube[i + 2*j + 4*k + 8*l][1] = 1.0 * (1 - 2 * j) * CUBESIZE;
                                	cube[i + 2*j + 4*k + 8*l][2] = 1.0 * (1 - 2 * k) * CUBESIZE;
                                	cube[i + 2*j + 4*k + 8*l][3] = 1.0 * (1 - 2 * l) * CUBESIZE;
					}
					
	for (i = 0; i < 2; i++)
		for (j = 0; j < 2; j++)
			for (k = 0; k < 2; k++) {
			    startline[i + 2*j + 4*k] = 0 + 2* i + 4*j + 8*k;
			    endline[i + 2*j + 4*k] = 1 + 2*i + 4*j + 8*k;
			    startline[i + 2*j + 4*k + 8] = 0 +  i + 4*j + 8*k;
			    endline[i + 2*j + 4*k + 8] = 2 + i + 4*j + 8*k;
			    startline[i + 2*j + 4*k + 16] = 0 +  i + 2*j + 8*k;
			    endline[i + 2*j + 4*k + 16] = 4 + i + 2*j + 8*k;
			    startline[i + 2*j + 4*k + 24] = 0 + i + 2*j + 4*k;
			    endline[i + 2*j + 4*k + 24] = 8 + i + 2*j + 4*k;
  			    } 
}

- (void)initialize4Octahedron
{
		int i, j, theline = 0;
	
	figure = OCTAHEDRON4;
	vertices = 8;
	lines = 24;
	cells = 16;

	for (i = 0; i < 8; i++) 
		for (j = 1; j <= 2; j++) {
			cube[i][2 * j - 2] = cos(i * (2 * j  - 1)* PI / 4) * OCTAHEDRON4SIZE;
			cube[i][2 * j - 1] = sin(i * (2 * j  - 1)* PI / 4) * OCTAHEDRON4SIZE;
			}
		
	for (i = 0; i < 7; i++)
	for (j = i + 1; j < 8; j++) 
		if ((j - i )!= 4) {
		switch(i) {
			case 0: if (j < 4) theline = j - 1; else theline = j - 2; break;
			case 1: if (j < 5) theline = j + 4; else theline = j + 3; break;
			case 2: if (j < 6) theline = j + 8; else theline = j + 7; break; 
			case 3: theline = j + 11; break;
			case 4: theline = j + 13; break;
			case 5: theline = j + 15; break;
			case 6: theline = 23; break;
			} 
		startline[theline] = i;
		endline[theline] = j;
		} 
}

- (void)initialize24Cell
{
	double	a, b, temp1, temp2;
	int		i;
	
	figure = CELL24;
	vertices = 24 ;
	lines = 96;
	cells = 24;
	
	a = sqrt(2.0) * CELL24SIZE;
	b = (sqrt(3.0) - 1) * CELL24SIZE;
	for (i = 0; i < 24; i++) {
		cube[i][0] = a * cos( i * PI / 12.0);
		cube[i][1] = a* sin(i * PI / 12.0);
		cube[i][2] = b * cos(5 * i * PI / 12.0);
		cube[i][3] = b * sin(5 * i * PI / 12.0);
		temp1 = a;
		temp2 = b;
		a = temp2;
		b = temp1;
		}
		
	for (i = 0; i < 12; i++) {
		startline[i] = 2 * i;
		if (i < 11) 
			endline[i] =  2 * i + 2; 
		else 
			endline[i] = 0;
		}
		
	for (i = 0; i < 12; i++) {
		startline[i + 12] = 2 * i;
		if (i  < 10) 
			endline[i + 12] =  2 * i + 4; 
		else 
			endline[i + 12] = 2 * i - 20; 
		}
		
	for (i = 0; i < 12; i++) {
		startline[i + 24] = 2*i;
		endline[i + 24] = 2 * i + 1;
		}
		
	for (i = 0; i < 12; i++) {
		startline[i + 36] = 2 * i;
		if (i <1) 
			endline[i + 36] =  23; 
		else 
			endline[i + 36] = 2 * i - 1;
		}
		
	for (i = 0; i < 12; i++) {
		startline[i + 48] = 2 * i;
		if (i < 10) 
			endline[i + 48] =  2 * i + 5; 
		else 
			endline[i + 48] = 2 * i - 19;
		}
		
	for (i = 0; i < 12; i++) {
		startline[i + 60] = 2 * i;
		if (i < 3) 
			endline[i + 60] =  2 * i + 19; 
		else 
			endline[i + 60] = 2 * i - 5;
		}
		
	for (i = 0; i < 12; i++) {
		startline[i + 72] = 2*i + 1;
		if (i < 10) 
			endline[i + 72] =  2 * i + 5; 
		else 
			endline[i + 72] = 2 * i - 19;
		}
 
 	for (i = 0; i < 12; i++) {
		startline[i + 84] = 2*i + 1;
		if (i < 7) 
			endline[i + 84] =  2 * i + 11; 
		else 
			endline[i + 84] = 2 * i - 13;
		} 
}

- (void)initialize120Cell
{
	int	i, j;
	
	figure = CELL120;
	vertices = 600;
	lines = 1200;
	cells = 120;
	
	for (i = 0; i < 600; i++)
		for (j = 0; j < 4; j++)
			cube[i][j] = cell120vertices[i][j];
			
	for (i = 0; i < 1200; i++) {
		startline[i] = cell120startlines[i];
		endline[i] = cell120endlines[i];
		} 

}

- (void)initialize600Cell
{
	double	a, b, c, d, temp1, temp2, temp3, temp4;
	int		i;
	
	figure = CELL600;
	vertices = 120;
	lines = 720;
	cells = 600;
	
	a = 1.0 * CELL600SIZE;
	b = 2 * cos(11 * PI / 30.0) * CELL600SIZE;
	c = (1 / (2 * cos(7 * PI / 30.0)) )* CELL600SIZE;
	d = (cos(14 * PI / 30.0) / cos(12 * PI / 30.0)) * CELL600SIZE;
	for (i = 0; i < 60; i++) {
		cube[i][0] = a * cos( i * PI / 30.0);
		cube[i][1] = a* sin(i * PI / 30.0);
		cube[i][2] = d * cos(11 * i * PI / 30.0);
		cube[i][3] = d * sin(11 * i * PI / 30.0);
		temp1 = a;
		temp2 = b;
		temp3 = c; 
		temp4 = d;
		a = temp2;
		b = temp1;
		c = temp4;
		d = temp3;
		}
		
	a = 1.0 * CELL600SIZE;
	b = 2 * cos(11 * PI / 30.0) * CELL600SIZE;
	c = (1 / (2 * cos(7 * PI / 30.0)) )* CELL600SIZE;
	d = (cos(14 * PI / 30.0) / cos(12 * PI / 30.0)) * CELL600SIZE;
	for (i = 0; i < 60; i++) {
		cube[i + 60][0] = d * cos( i * PI / 30.0);
		cube[i + 60][1] = d* sin(i * PI / 30.0);
		cube[i + 60][2] = - a * cos(11 * i * PI / 30.0);
		cube[i + 60][3] = - a * sin(11 * i * PI / 30.0);
		temp1 = a;
		temp2 = b;
		temp3 = c; 
		temp4 = d;
		a = temp2;
		b = temp1;
		c = temp4;
		d = temp3;
		}

		
/* AA */
 
 	for (i = 0; i < 30; i++) {
		startline[i] = 2 * i;
		endline[i] = (2 * i + 2) % 60;
		}
		
	for (i = 0; i < 30; i++) {
		startline[i + 30] = 2 * i;
		endline[i + 30] = (2 * i + 4) % 60;
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 60] = 2 * i;
		endline[i+ 60] =  (2 * i + 6) % 60; 
		}
 
/*AB */
 
	for (i = 0; i < 30; i++) {
		startline[i+ 90] = 2 * i;
		endline[i+ 90] =  (2 * i + 1) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 120] = 2 * i;
		endline[i+ 120] =  (2 * i + 60 - 1) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 150] = 2 * i;
		endline[i+ 150] =  (2 * i + 5) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 180] = 2 * i;
		endline[i+ 180] =  (2 * i  + 60 - 5) % 60; 
		}
		
/* AC */

	for (i = 0; i < 30; i++) {
		startline[i+ 210] = 2 * i;
		endline[i+ 210] =  60 + (2*i + 3) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 240] = 2 * i;
		endline[i+ 240] =  60 + (2* i + 60 - 3)% 60; 
		}
 
/* BB */
 
	for (i = 0; i < 30; i++) {
		startline[i+ 270] = 2 * i + 1;
		endline[i+ 270] =  (2 * i + 1 + 6) % 60; 
		}

/* BC */

	for (i = 0; i < 30; i++) {
		startline[i+ 300] = 2 * i + 1;
		endline[i+ 300] =  60 + (2 * i + 1 + 2) % 60; 
		}
		
	for (i = 0; i < 30; i++) {
		startline[i+ 330] = 2 * i + 1;
		endline[i+ 330] =  60 + (2 * i + 1 + 60 - 2) % 60; 
		}
		
	for (i = 0; i < 30; i++) {
		startline[i+ 360] = 2 * i + 1;
		endline[i+ 360] =  60 + (2 * i + 1 + 8) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 390] = 2 * i + 1;
		endline[i+ 390] =  60 + (2 * i + 1 + 60 - 8) % 60; 
		}

/* BD */
 
	for (i = 0; i < 30; i++) {
		startline[i+ 420] = 2 * i + 1;
		endline[i+ 420] =  60 + (2 * i + 1 + 3) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 450] = 2 * i + 1;
		endline[i+ 450] =  60 + (2 * i + 1 + 60 - 3) % 60; 
		}

/* CC */
 
	for (i = 0; i < 30; i++) {
		startline[i+ 480] = 2 * i +  60 +1 ;
		endline[i+ 480] =  60 + (2 * i + 1 + 6) % 60; 
		}

/* CD */

	for (i = 0; i < 30; i++) {
		startline[i+ 510] = 2 * i + 60 + 1;
		endline[i+ 510] =  60 + (2 * i + 1 + 5) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 540] = 2 * i + 60 + 1;
		endline[i+ 540] =  60 + (2 * i + 1 + 60 - 5) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 570] = 2 * i + 60 + 1;
		endline[i+ 570] =  60 + (2 * i + 1 + 11) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 600] = 2 * i + 60 + 1;
		endline[i+ 600] =  60 + (2 * i + 1 + 60 - 11 ) % 60; 
		}

/* DD */
 
	for (i = 0; i < 30; i++) {
		startline[i+ 630] = 2 * i + 60;
		endline[i+ 630] =  60 + (2 * i + 6) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 660] = 2 * i + 60;
		endline[i+ 660] =  60 + (2 * i + 16) % 60; 
		}

	for (i = 0; i < 30; i++) {
		startline[i+ 690] = 2 * i + 60;
		endline[i+ 690] =  60 + (2 * i + 22) % 60; 
		} 
}

- (void)ChangeCellNumber:sender
{
	int	currentvalue, newvalue;
	
	currentvalue = [WhichCell intValue];
	newvalue = [self CheckCellValue :currentvalue];
	selectedcell = newvalue;
	if (newvalue != currentvalue) {
		[WhichCell setIntValue:newvalue];
		}
	if  ([[CellRadio cellWithTag:1] intValue] == 1)
		[self ReDraw:self]; 
}

- (int)CheckCellValue:(int) thevalue
{
	while (thevalue <= 0)
		thevalue = thevalue + cells;
	while (thevalue > cells)
		thevalue = thevalue - cells;		
	return (thevalue);
}

- (void)ChangeCell:sender
{
	int	currentvalue, newvalue;
	
	currentvalue = [WhichCell intValue];
	if ([sender tag] == 0) 
		currentvalue = currentvalue - 1;
	else
		currentvalue = currentvalue + 1;
	newvalue = [self CheckCellValue :currentvalue];
	[WhichCell setIntValue:newvalue];
	selectedcell = newvalue;
	if  ([[CellRadio cellWithTag:1] intValue] == 1) 
		[self ReDraw:self]; 
}

- (void)ChangeCellColor:sender
{
	cellcolor = [sender tag];
	[self display]; 
}

- (void)ChangeCellState:sender
{
	/* if  ([[CellRadio cellWithTag:1] intValue] == 1) */
        if ([sender selectedTag] == 1) {
		[FrontBack setEnabled:NO];
                [[CellRadio cellWithTag:0] setIntValue:0];
                [[CellRadio cellWithTag:1] setIntValue:1];
                }
	else {
		[[CellRadio cellWithTag:0] setIntValue:1];
                [[CellRadio cellWithTag:1] setIntValue:0];
                if ((figure == CUBE) || (figure == CUBE4))
			[FrontBack setEnabled:YES];
		if (figure == CUBE)
			[[FrontBack cellWithTag:4] setEnabled:NO];
		}
	[self ReDraw:self];
}

- initWithFrame:(NSRect)frameRect
{
	int 		i;
	NSPoint		hotspot;
	
	self = [super initWithFrame:frameRect];

        [NSBezierPath setDefaultLineWidth:0.8];
	
	background = 0;
	clarge = cos(5.0 * 3.14159 / 180.0);
	slarge = sin(5.0 * 3.14159 / 180.0);
	csmall = cos(1.0 * 3.14159 / 180.0);
	ssmall = sin(1.0 * 3.14159 / 180.0);

	for (i = 0; i <= 1; i++) {
		[[XYButton cellWithTag:i] setPeriodicDelay:DELAY interval:INTERVAL];
		[[XZButton cellWithTag:i] setPeriodicDelay:DELAY interval:INTERVAL];
		[[XWButton cellWithTag:i] setPeriodicDelay:DELAY interval:INTERVAL];
		[[YZButton cellWithTag:i] setPeriodicDelay:DELAY interval:INTERVAL];
		[[YWButton cellWithTag:i] setPeriodicDelay:DELAY interval:INTERVAL];
		[[ZWButton cellWithTag:i] setPeriodicDelay:DELAY interval:INTERVAL];
		}
	[self initialize4Cube];
	cellcolor = CELLBLUE;
	withperspective = NO;
	distance = 10.0;
	madefirstresponder = NO;
	selectedcell = 1;
	timerActive = NO;
	whichRotation = XYROT;
	LR = 1;
	hotspot.x = 0.8; hotspot.y = 0.8;
	return self;
}

- (void)drawLine:(int)i
{
    NSPoint frompoint, topoint;
    
	if (withperspective) {
            frompoint.x =centerx + cubesize * cube[startline[i]][0] / (1.0 - cube[startline[i]][2] / distance);                        		frompoint.y = centery + cubesize * cube[startline[i]][1]/ (1.0 - cube[startline[i]][2] / distance);
            topoint.x = centerx + cubesize * cube[endline[i]][0]/ (1.0 - cube[endline[i]][2] / distance);
            topoint.y = centery + cubesize * cube[endline[i]][1]/ (1.0 - cube[endline[i]][2] / distance);
                [NSBezierPath strokeLineFromPoint:frompoint toPoint:topoint];
		}
		
	else {
            frompoint.x = centerx + cubesize * cube[startline[i]][0];
            frompoint.y = centery + cubesize * cube[startline[i]][1];
            topoint.x = centerx + cubesize * cube[endline[i]][0];
            topoint.y = centery + cubesize * cube[endline[i]][1];
            [NSBezierPath strokeLineFromPoint:frompoint toPoint:topoint];
		} 
}

-determineLine:(int)i : (NSPoint*)startPt :(NSPoint *)endPt
{
	if (withperspective) {
	
		startPt->x = centerx + cubesize * cube[startline[i]][0] / (1.0 - cube[startline[i]][2] / distance);
		startPt->y =  centery + cubesize * cube[startline[i]][1]/ (1.0 - cube[startline[i]][2] / distance);
		endPt->x = centerx + cubesize * cube[endline[i]][0]/ (1.0 - cube[endline[i]][2] / distance); 
		endPt->y =	centery + cubesize * cube[endline[i]][1]/ (1.0 - cube[endline[i]][2] / distance);
		
		}
		
	else {
	
		startPt->x = centerx + cubesize * cube[startline[i]][0];
		startPt->y =  centery + cubesize * cube[startline[i]][1];
		endPt->x = centerx + cubesize * cube[endline[i]][0];
		endPt->y =  centery + cubesize * cube[endline[i]][1];
		
		}

	return self;

}



- (void)drawRect:(NSRect)rects
{	
	double 	maxsize;
	int	i;
	int	axes[5];
        NSRect	myRect;
	
	if (! madefirstresponder) {
		madefirstresponder = YES;
		[[self window] makeFirstResponder:self];
		}		
	
	centerx = [self bounds].origin.x + [self bounds].size.width / 2.0;
	centery = [self bounds].origin.y + [self bounds].size.height / 2.0;
	
	switch (background) {
                case 0: [[NSColor whiteColor] set]; break;
                case 1: [[NSColor lightGrayColor] set]; break;
                case 2: [[NSColor darkGrayColor] set]; break;
                case 3: [[NSColor blackColor] set]; break;
		}
        myRect = [self bounds];
        NSRectFill(myRect);
	switch (background) {
                case 0: [[NSColor blackColor] set]; break;
                case 1: [[NSColor blackColor] set]; break;
                case 2: [[NSColor whiteColor] set]; break;
                case 3: [[NSColor whiteColor] set]; break;
		}
	
	/* code to draw figure */
		
		maxsize = [self bounds].size.width / 2.0;
		if (maxsize > [self bounds].size.height/2.0) 
			maxsize = [self bounds].size.height / 2.0;
		cubesize = [SizeBar doubleValue] * maxsize;
		for (i = 0; i < lines; i++)	
			[self drawLine:i];
		/*PSstroke();*/
		
	/* code to draw cells */
	
		if ([[CellRadio cellWithTag:1] intValue] == 1)
			[self DrawCell];
		
	/* code to draw sides of cubes */
		
		else if ((figure == CUBE) || (figure == CUBE4))  {
		
		    for (i = 0; i < 5; i++)
			    axes[i] = [[FrontBack cellWithTag:i] intValue];
	    
		    /* PSsetlinewidth(4.0); */
                    [NSBezierPath setDefaultLineWidth:4.0];
		   if (cellcolor != CELLBLACK)
                   switch(cellcolor) {
                        case CELLRED: [[NSColor redColor] set]; break;
                        case CELLGREEN: [[NSColor greenColor] set]; break;
                        case CELLBLUE: [[NSColor blueColor] set]; break;
                        case CELLCYAN: [[NSColor cyanColor] set]; break;
                        case CELLMAGENTA: [[NSColor magentaColor] set]; break;
                        case CELLYELLOW: [[NSColor yellowColor] set]; break;
                             }

		    
		    if (axes[1] == 1)  {
		    		if (figure == CUBE4) {
		    			for (i = 8; i < 32; i++)
				    		[self drawLine:i];
					}
		   		else {
					for (i = 4; i < 12; i++)
						[self drawLine:i]; 
					}
				}
			    
		    if (axes[2] == 1)  {
		    		if (figure == CUBE4) { 
		    			for (i = 0; i < 8; i++)								[self drawLine:i];
					for (i = 16; i < 32; i++)
				    		[self drawLine:i];
					}
				else {
					for (i = 0; i < 4; i++)								[self drawLine:i];
					for (i = 8; i < 12; i++)
				    		[self drawLine:i];
					}
				}
    
		    if (axes[3] == 1) { 
		    		if (figure == CUBE4) {
		    			for (i = 0; i < 16; i++)
				    		[self drawLine:i];
			    		for (i = 24; i < 32; i++)
				    		[self drawLine:i];
					}
				else {
					for (i = 0; i < 8; i++)
						[self drawLine:i];
					}
				}
    
		    if (axes[4] == 1) {
		    		for (i = 0; i < 24; i++)
				   	[self drawLine:i];
				}
    
                       [NSBezierPath setDefaultLineWidth:0.8];
		    if (cellcolor != CELLBLACK)
                        [[NSColor blackColor] set];
		}
}

- (void)DrawCell
{
	int 		i, j, themod, thedivide, thecell;
	int		theChoices[4];
	BOOL	theBool;
	
       [NSBezierPath setDefaultLineWidth:4.0];
	if (cellcolor != CELLBLACK)
		switch(cellcolor) {
                        case CELLRED: [[NSColor redColor] set]; break;
                        case CELLGREEN: [[NSColor greenColor] set]; break;
                        case CELLBLUE: [[NSColor blueColor] set]; break;
                        case CELLCYAN: [[NSColor cyanColor] set]; break;
                        case CELLMAGENTA: [[NSColor magentaColor] set]; break;
                        case CELLYELLOW: [[NSColor yellowColor] set]; break;
  			}
	
	thecell = selectedcell;
	thecell = thecell - 1;
	switch(figure) {
		
		case TETRAHEDRON:
		
		case TETRAHEDRON4:
			for (i = 0; i < lines; i++)
				if ((startline[i] != thecell) && (endline[i] != thecell))
					[self drawLine:i];
			break;
			
		case CUBE:
		
		case CUBE4:
			theBool = (thecell % 2 == 0);
			if  (thecell < 2)
				themod = 2;
			else if (thecell < 4)
				themod = 4;
			else if (thecell < 6)
				themod = 8;
			else
				themod = 16;
			thedivide = themod / 2;
			for (i = 0; i < lines; i++)
				if (theBool) { 
					if (((startline[i] %  themod) >=  thedivide) 
						&& ((endline[i] %  themod) >= thedivide))
						[self drawLine:i];
					}
				else
					if (((startline[i] %  themod) < thedivide) 
						&& ((endline[i] %  themod) < thedivide))
						[self drawLine:i];

			break;
			
		case OCTAHEDRON:
		
		case OCTAHEDRON4:
		
			if ((thecell % 2) == 0)
				theChoices[0] = 0;
			else
				theChoices[0] = vertices / 2;
			if ((thecell % 4) < 2)
				theChoices[1] = 1;
			else
				theChoices[1] = vertices / 2 + 1;
			if ((thecell % 8) < 4)
				theChoices[2] = 2;
			else
				theChoices[2] = vertices / 2 + 2;
			if ((thecell % 16) < 8)
				theChoices[3] = 3;
			else
				theChoices[3] = vertices / 2 + 3;

			for (i = 0; i < lines; i++)
				if  ((theChoices[startline[i] % (vertices / 2)]  == startline[i]) &&
					(theChoices[endline[i] % (vertices / 2)]  == endline[i]))
						[self drawLine:i];
					
			break;
			
		case DODECAHEDRON:
			for (i = 0; i < 5; i++)
				[self drawLine:dodecahedroncells[thecell][i]];
			break;
			
		case ICOSAHEDRON:
			for (i = 0; i < 3; i++)
				[self drawLine:icosahedroncells[thecell][i]];
			break;
			
		case CELL24:
		
			if ((thecell % 2) == 0) {
				i = thecell  / 2;
				[self drawLine:(0 + i)%12];
				[self drawLine:12 + (0 + i)%12];
				[self drawLine:48 + (0 + i)%12];
				[self drawLine:24 + (0 + i)%12];
				[self drawLine:(1 + i)%12];
				[self drawLine:12 + (1 + i)%12];
				[self drawLine:36 + (1 + i)%12];
				[self drawLine:(2 + i)%12];
				[self drawLine:24 + (2 + i)%12];
				[self drawLine:36 + (3 + i)%12];
				[self drawLine:60 + (3 + i)%12];
				[self drawLine:72 + (0 + i)%12];
				}
			else {
				i = (thecell - 1) / 2;
				[self drawLine:84 + (0 + i)%12];
				[self drawLine:72 + (10 + i)%12];
				[self drawLine:36 + (1 + i)%12];
				[self drawLine:60 + (3 + i)%12];
				[self drawLine:84 + (5 + i)%12];
				[self drawLine:72 + (3 + i)%12];
				[self drawLine:48 + (3 + i)%12];
				[self drawLine:84 + (10 + i)%12];
				[self drawLine:60 + (1 + i)%12];
				[self drawLine:48 + (1 + i)%12];
				[self drawLine:24 + (3 + i)%12];
				[self drawLine:12 + (1 + i)%12];
				}

			break;
				
		case CELL120:
 			for (i = 0; i < 30; i++)
				[self drawLine:cell120cells[thecell][i]];
			break;
			
		case CELL600:
			j = thecell % 20;
			i = (thecell - j) / 20;
			switch(j) {
				case 0: /* AAAA */
					[self drawLine:(0 + i) % 30];
					[self drawLine:(1 + i) % 30];
					[self drawLine:(2 + i) % 30];
					[self drawLine:30 + (0 + i) % 30];
					[self drawLine:30 + (1 + i) % 30];
					[self drawLine:60 + (0 + i) % 30];
					break;
				case 1: /* AABB */
					[self drawLine:30 + (5 + i) % 30];
					[self drawLine:120 + (5 + i) % 30];
					[self drawLine:150 + (5 + i) % 30];
					[self drawLine:180 + (7 + i) % 30];
					[self drawLine:90 + (7 + i) % 30];
					[self drawLine:270 + (4 + i) % 30];
					break;
				case 2: /* CCDD */
					[self drawLine:480 + (7 + i) % 30];
					[self drawLine:540 + (7 + i) % 30];
					[self drawLine:570 + (7 + i) % 30];
					[self drawLine:600 + (10 + i) % 30];
					[self drawLine:510 + (10 + i) % 30];
					[self drawLine:660 + (5 + i) % 30];
					break;
				case 3: /* DDDD */
					[self drawLine:660 + (0 + i) % 30];
					[self drawLine:690 + (19 + i) % 30];
					[self drawLine:630 + (27 + i) % 30];
					[self drawLine:690 + (8 + i) % 30];
					[self drawLine:690 + (27 + i) % 30];
					[self drawLine:660 + (19 + i) % 30];
					break;
				case 4: /* AAAB 1 */
					[self drawLine:30 + (2 + i) % 30];
					[self drawLine:60 + (2 + i) % 30];
					[self drawLine:150 + (2 + i) % 30];
					[self drawLine:0 + (4 + i) % 30];
					[self drawLine:90 + (4 + i) % 30];
					[self drawLine:120 + (5 + i) % 30];
					break;
				case 5: /* AAAB 2 */
					[self drawLine:0 + (4 + i) % 30];
					[self drawLine:60 + (4 + i) % 30];
					[self drawLine:90 + (4 + i) % 30];
					[self drawLine:30 + (5 + i) % 30];
					[self drawLine:120 + (5 + i) % 30];
					[self drawLine:180 + (7 + i) % 30];
					break;
				case 6: /* AABC 1 */
					[self drawLine:60 + (7 + i) % 30];
					[self drawLine:90 + (7 + i) % 30];
					[self drawLine:210 + (7 + i) % 30];
					[self drawLine:180 + (10 + i) % 30];
					[self drawLine:240 + (10 + i) % 30];
					[self drawLine:300 + (7 + i) % 30];
					break;
				case 7: /* AABC 2 */
					[self drawLine:60 + (10 + i) % 30];
					[self drawLine:150 + (10 + i) % 30];
					[self drawLine:210 + (10 + i) % 30];
					[self drawLine:120 + (13 + i) % 30];
					[self drawLine:240 + (13 + i) % 30];
					[self drawLine:330 + (12 + i) % 30];
					break;
				case 8: /* ABBC 1 */
					[self drawLine:180 + (7 + i) % 30];
					[self drawLine:90 + (7 + i) % 30];
					[self drawLine:210 + (7 + i) % 30];
					[self drawLine:270 + (4 + i) % 30];
					[self drawLine:360 + (4 + i) % 30];
					[self drawLine:300 + (7 + i) % 30];
					break;
				case 9: /* ABBC 2 */
					[self drawLine:120 + (13 + i) % 30];
					[self drawLine:150 + (13 + i) % 30];
					[self drawLine:240 + (13 + i) % 30];
					[self drawLine:270 + (12 + i) % 30];
					[self drawLine:330 + (12 + i) % 30];
					[self drawLine:390 + (15 + i) % 30];
					break;
				case 10: /* ABCC 1 */
					[self drawLine:180 + (10 + i) % 30];
					[self drawLine:240 + (10 + i) % 30];
					[self drawLine:210 + (10 + i) % 30];
					[self drawLine:300 + (7 + i) % 30];
					[self drawLine:360 + (7 + i) % 30];
					[self drawLine:480 + (8 + i) % 30];
					break;
				case 11: /* ABCC 2 */
					[self drawLine:150 + (10 + i) % 30];
					[self drawLine:240 + (10 + i) % 30];
					[self drawLine:210 + (10 + i) % 30];
					[self drawLine:390 + (12 + i) % 30];
					[self drawLine:330 + (12 + i) % 30];
					[self drawLine:480 + (8 + i) % 30];
					break;
				case 12: /* BBCD 1 */
					[self drawLine:270 + (8 + i) % 30];
					[self drawLine:330 + (8 + i) % 30];
					[self drawLine:420 + (8 + i) % 30];
					[self drawLine:390 + (11 + i) % 30];
					[self drawLine:450 + (11 + i) % 30];
					[self drawLine:510 + (7 + i) % 30];
					break;
				case 13: /* BBCD 2 */
					[self drawLine:270 + (8 + i) % 30];
					[self drawLine:360 + (8 + i) % 30];
					[self drawLine:420 + (8 + i) % 30];
					[self drawLine:300 + (11 + i) % 30];
					[self drawLine:450 + (11 + i) % 30];
					[self drawLine:540 + (12 + i) % 30];
					break;
				case 14: /* BCCD 1 */
					[self drawLine:390 + (11 + i) % 30];
					[self drawLine:330 + (11 + i) % 30];
					[self drawLine:420 + (11 + i) % 30];
					[self drawLine:480 + (7 + i) % 30];
					[self drawLine:570 + (7 + i) % 30];
					[self drawLine:510 + (10 + i) % 30];
					break;
				case 15: /* BCCD 2 */
					[self drawLine:300 + (8 + i) % 30];
					[self drawLine:360 + (8 + i) % 30];
					[self drawLine:450 + (8 + i) % 30];
					[self drawLine:480 + (9 + i) % 30];
					[self drawLine:540 + (9 + i) % 30];
					[self drawLine:600 + (12 + i) % 30];
					break;
				case 16: /* BCDD 1 */
					[self drawLine:390 + (11 + i) % 30];
					[self drawLine:450 + (11 + i) % 30];
					[self drawLine:420 + (11 + i) % 30];
					[self drawLine:510 + (7 + i) % 30];
					[self drawLine:570 + (7 + i) % 30];
					[self drawLine:630 + (10 + i) % 30];
					break;
				case 17: /* BCDD 2 */
					[self drawLine:360 + (8 + i) % 30];
					[self drawLine:450 + (8 + i) % 30];
					[self drawLine:420 + (8 + i) % 30];
					[self drawLine:600 + (12 + i) % 30];
					[self drawLine:540 + (12 + i) % 30];
					[self drawLine:630 + (7 + i) % 30];
					break;
				case 18: /* CDDD 1 */
					[self drawLine:600 + (10 + i) % 30];
					[self drawLine:540 + (10 + i) % 30];
					[self drawLine:570 + (10 + i) % 30];
					[self drawLine:630 + (5 + i) % 30];
					[self drawLine:690 + (5 + i) % 30];
					[self drawLine:660 + (8 + i) % 30];
					break;
				case 19: /* CDDD 2 */
					[self drawLine:600 + (10 + i) % 30];
					[self drawLine:510 + (10 + i) % 30];
					[self drawLine:570 + (10 + i) % 30];
					[self drawLine:660 + (5 + i) % 30];
					[self drawLine:690 + (5 + i) % 30];
					[self drawLine:630 + (13 + i) % 30];
					break;
				} 
			break;
		}
		    
        [NSBezierPath setDefaultLineWidth:0.8];
        if (cellcolor != CELLBLACK)
                [[NSColor blackColor] set];
}

- (void)copy:(id)sender
{
	id		pb;
	NSData		*stream;
	NSRect		boundsR, figureR, lineR;
        NSPoint		viewPt;
	NSPoint		startPt, endPt;
	double		maxsize;
	double		x, y, width, height;
	int		i;
	
	boundsR = [self bounds];
        viewPt = [self convertPoint:boundsR.origin toView:nil];
	
	centerx = [self bounds].origin.x + [self bounds].size.width / 2.0;
	centery = [self bounds].origin.y + [self bounds].size.height / 2.0;
	maxsize = [self bounds].size.width / 2.0;
	if (maxsize > [self bounds].size.height/2.0) 
		maxsize = [self bounds].size.height / 2.0;
	cubesize = [SizeBar doubleValue] * maxsize;
	for (i = 0; i < lines; i++) {	
		[self determineLine:i :&startPt :&endPt];
		if (startPt.x < endPt.x) {
			x = startPt.x;
			width = endPt.x - startPt.x + 1.0;
			}
		else {
			x = endPt.x;
			width = startPt.x - endPt.x + 1.0; 
			}
		if (startPt.y < endPt.y) {
			y = startPt.y;
			height = endPt.y - startPt.y + 1.0;
			}
		else {
			y = endPt.y;
			height = startPt.y - endPt.y+ 1.0;
			}
		lineR = NSMakeRect(x, y, width, height);
		if (i == 0)
			figureR = lineR;
		else
			figureR  = NSUnionRect(lineR , figureR);
		}
	figureR = NSInsetRect(figureR , -4.0 , -4.0);
	figureR = NSIntersectionRect(boundsR , figureR);
        /* The next lines subtract the coordinates of the lower left of the
        NSImage. It is mysterious why these lines are necessary! */
        figureR.origin.x = figureR.origin.x - viewPt.x;
        figureR.origin.y = figureR.origin.y - viewPt.y;
  	pb = [NSPasteboard generalPasteboard];
	[pb declareTypes:[NSArray arrayWithObject:NSPDFPboardType] owner:self];
	stream = [self dataWithPDFInsideRect:figureR]; ;
        [pb setData:stream forType:NSPDFPboardType];
}

- (BOOL) acceptsFirstResponder
{
	return YES;
}


- (void)XW:sender
{	

	whichRotation = XWROT;
        LR =[[sender selectedCell] tag];
	if (! timerActive) [self doRotate];
}

- (void)YW:sender
{	

        whichRotation = YWROT;
        LR =[[sender selectedCell] tag];
        if (! timerActive) [self doRotate];
}

- (void)ZW:sender
{	

        whichRotation = ZWROT;
        LR =[[sender selectedCell] tag];
        if (! timerActive) [self doRotate];
}

- (void)XY:sender
{	

        whichRotation = XYROT;
        LR =[[sender selectedCell] tag];
        if (! timerActive) [self doRotate];
}

- (void)XZ:sender
{	

        whichRotation = ZXROT;
        LR =[[sender selectedCell] tag];
        if (! timerActive) [self doRotate];
}

- (void)YZ:sender
{	

        whichRotation = YZROT;
        LR =[[sender selectedCell] tag];
        if (! timerActive) [self doRotate];
}


- (void)ReDraw:sender
{
	[self display]; 
}

- (void)Initialize:sender
{
    	switch (figure) {
		case TETRAHEDRON:		[self initializeTetrahedron]; break;
		case CUBE: 				[self initializeCube]; break;
		case OCTAHEDRON: 		[self initializeOctahedron]; break;
		case DODECAHEDRON:	[self initializeDodecahedron]; break;
		case ICOSAHEDRON: 		[self initializeIcosahedron]; break;
		case TETRAHEDRON4:	[self initialize4Tetrahedron]; break;
		case CUBE4: 				[self initialize4Cube]; break;
		case OCTAHEDRON4: 		[self initialize4Octahedron]; break;
		case CELL24: 			[self initialize24Cell]; break;		
		case CELL120: 			[self initialize120Cell]; break;		
		case CELL600: 			[self initialize600Cell]; break;		}
		
    	[self display]; 
}

- (void)SetWhite:sender
{
	background = 0;
	[self display]; 
}

- (void)SetLtGray:sender
{
	background = 1;
	[self display]; 
}

- (void)SetDkGray:sender
{
	background = 2;
	[self display]; 
}

- (void)SetBlack:sender
{

	background = 3;
	[self display]; 
}

- (void)AdjustP:sender
{
	int	thetag;
	
	thetag =[[sender selectedCell] tag];
	switch (thetag) {
		case 0:
			withperspective = NO;
			break;
			
		case 1:
			withperspective = YES;
			break;
		}	
	
	[self ReDraw:self]; 
}

- AdjustDistance:sender
{
	distance = [sender floatValue];
	[self ReDraw:self];
	return self;
}


- (void)SetAngle:(int)leftright :(int)slowfast

{
	
	C = csmall;
	S = ssmall;

	if (slowfast == 1) {
		C = clarge;
		S = slarge;
		}
	if (leftright == 1) 
		S = - S; 
}

- (void)FixBoxTitle
{
NSRect	TitleRect;

TitleRect = [MyBox bounds];
TitleRect.origin.x = 0.0;
TitleRect.origin.y = TitleRect.size.height - TITLEHEIGHT;
TitleRect.size.height = TITLEHEIGHT;
[MyBox displayRect:TitleRect]; 
}

- (void)FixFor3D
{
whichRotation = XYROT;
[XWButton setEnabled:NO];
[YWButton setEnabled:NO];
[ZWButton setEnabled:NO]; 
}

- (void)FixFor4D
{

[XWButton setEnabled:YES];
[YWButton setEnabled:YES];
[ZWButton setEnabled:YES]; 
}

- (void)SetTetrahedron:sender
{

[MyBox setTitle:@"Three Dimensional Tetrahedron"];
[self FixBoxTitle];
[FrontBack setEnabled:NO];
[FrontBack selectCellWithTag:0];
[self FixFor3D];
[self initializeTetrahedron];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)SetCube:sender
{

[MyBox setTitle:@"Three Dimensional Cube"];
[self FixBoxTitle];
[FrontBack selectCellWithTag:0];
if ([[CellRadio cellWithTag:1] intValue] == 0) {
    [FrontBack setEnabled:YES];
    [[FrontBack cellWithTag:4] setEnabled:NO];
    }
[self FixFor3D];
[self initializeCube];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)SetOctahedron:sender
{

[MyBox setTitle:@"Three Dimensional Octahedron"];
[self FixBoxTitle];
[FrontBack setEnabled:NO];
[FrontBack selectCellWithTag:0];
[self FixFor3D];
[self initializeOctahedron];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)SetDodecahedron:sender
{

[MyBox setTitle:@"Three Dimensional Dodecahedron"];
[self FixBoxTitle];
[FrontBack setEnabled:NO];
[FrontBack selectCellWithTag:0];
[self FixFor3D];
[self initializeDodecahedron];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)SetIcosahedron:sender
{

[MyBox setTitle:@"Three Dimensional Icosahedron"];
[self FixBoxTitle];
[FrontBack setEnabled:NO];
[FrontBack selectCellWithTag:0];
[self FixFor3D];
[self initializeIcosahedron];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)Set4Tetrahedron:sender
{
	
[MyBox setTitle:@"Four Dimensional Tetrahedron"];
[self FixBoxTitle];
[FrontBack setEnabled:NO];
[FrontBack selectCellWithTag:0];
[self FixFor4D];
[self initialize4Tetrahedron];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)Set4Cube:sender
{

[MyBox setTitle:@"Four Dimensional Cube"];
[self FixBoxTitle];
[FrontBack selectCellWithTag:0];
if ([[CellRadio cellWithTag:1] intValue] == 0) {
    [FrontBack setEnabled:YES];
    [[FrontBack cellWithTag:4] setEnabled:YES];
    }
[self FixFor4D];
[self initialize4Cube];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)Set4Octahedron:sender
{

[MyBox setTitle:@"Four Dimensional Octahedron"];
[self FixBoxTitle];
[FrontBack setEnabled:NO];
[FrontBack selectCellWithTag:0];
[self FixFor4D];
[self initialize4Octahedron];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)Set24Cell:sender
{

[MyBox setTitle:@"Four Dimensional 24-Cell"];
[self FixBoxTitle];
[FrontBack setEnabled:NO];
[FrontBack selectCellWithTag:0];
[self FixFor4D];
[self initialize24Cell];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)Set120Cell:sender
{

[MyBox setTitle:@"Four Dimensional 120-Cell"];
[self FixBoxTitle];
[FrontBack setEnabled:NO];
[FrontBack selectCellWithTag:0];
[self FixFor4D];
[self initialize120Cell];
[WhichCell setIntValue:1];
[self display]; 
}

- (void)Set600Cell:sender
{

[MyBox setTitle:@"Four Dimensional 600-Cell"];
[self FixBoxTitle];
[FrontBack setEnabled:NO];
[FrontBack selectCellWithTag:0];
[self FixFor4D];
[self initialize600Cell];
[WhichCell setIntValue:1];
[self display]; 
}

- (BOOL)acceptsFirstMouse:(NSEvent *)theEvent
{
	return YES;
}

@end

